var valor = [0, 0, 0];
var dec_pos = [0, 0, 0];
var op = "";
var newNum = false;
var curr = 0;

var ratio = 1.0875712;
var dec = [2, 2, 2];
var pow = [100, 100, 100];

var txt_diplay = [null, null, null];

var lbl_tip_1 = [null, null, null];
var lbl_tip_2 = [null, null, null];
var txt_moneda = [null, null, null];
var ddl_moneda = [null, null, null];
var txt_tip = [null, null, null, null, null, null];
var txt_cambio = null;

var btn_d = [null, null, null];

var moneda = ['', 'EUR', 'USD'];

var btn_div = null;
var btn_mult = null;
var btn_plus = null;
var btn_minus = null;

var btn_refresh = null;

var fun_queue = [];
var fun_lock = false;

var div_config = null;

var div_tips = null;
var btn_tips = null;
var show_tips = true;
var tips = [0, 0.050, 0.075, 0.100, 0.125, 0.150];
var stars = 3;

var btn_haptic = null;
var haptic = true;
var haptic_time = 50;

var star = [null, null, null, null, null, null];

var ul_monedas = null;
var cur_ddl_moneda = 0;

var curPage = 0;

function EnQueue(fn, params){
	fun_queue.push(
		function() {
			fun_lock = true;
			fn.apply(this, params);
			fun_lock = false;
			DeQueue();
		}
	);
	setTimeout(function(){DeQueue();}, 1);
}

function DeQueue(){
	if(!fun_lock && 0 < fun_queue.length){
		(fun_queue.shift())();
	}
}

function Format(v, c){
	var parts = (Math.round(parseFloat(v) * pow[c]) / pow[c]).toFixed(dec[c]).split(".");
    parts[0] = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, ".");
	if(0 == dec[c]){
		return parts[0];
	}else{
		return parts.join("'");
	}
}

function UpdateDisplay(){
	txt_diplay[1].innerHTML =  Format(valor[1], 1);	
	txt_diplay[2].innerHTML =  Format(valor[2], 2);	
    UpdateTips();
}

function UpdateTips(){
	lbl_tip_1[1].innerHTML =  Format(valor[1]*(tips[stars]), 1);	
	lbl_tip_1[2].innerHTML =  Format(valor[2]*(tips[stars]), 2);	
	lbl_tip_2[1].innerHTML =  Format(valor[1]*(1+tips[stars]), 1);	
	lbl_tip_2[2].innerHTML =  Format(valor[2]*(1+tips[stars]), 2);	
}

function AddClass(obj, c){
	if(-1 == obj.className.indexOf(c)){
		obj.className += ' ' + c;
	}
}

function DelClass(obj, c){
	obj.className = obj.className.replace(c, '');
}

function Reset(){
	valor[0] = 0;
	op = "";
	newNum = false;
	for(var i = 1; i <= 2; ++i){
		valor[i] = 0;
		dec_pos[i] = 0;
		DelClass(btn_d[i], 'down');
		if(0 == dec[i]){
			AddClass(btn_d[i], 'dis');
		}else{
			DelClass(btn_d[i], 'dis');
		}
	}
	DelClass(btn_div, 'down');
	DelClass(btn_mult, 'down');
	DelClass(btn_plus, 'down');
	DelClass(btn_minus, 'down');
	UpdateDisplay();
}

function Init(){
	txt_diplay[1] = document.getElementById('txt_diplay_1');
	txt_diplay[2] = document.getElementById('txt_diplay_2');

	btn_d[1] = document.getElementById('btn_1_d');
	btn_d[2] = document.getElementById('btn_2_d');

	btn_div = document.getElementById('btn_div');
	btn_mult = document.getElementById('btn_mult');
	btn_plus = document.getElementById('btn_plus');
	btn_minus = document.getElementById('btn_minus');

    div_config = document.getElementById('div_config');

	div_tips = document.getElementById('div_tips');

	btn_tips = document.getElementById('btn_tips');
	btn_refresh = document.getElementById('btn_refresh');
    btn_haptic = document.getElementById('btn_haptic');
	
    lbl_tip_1[1] = document.getElementById('lbl_tip_1_1');
	lbl_tip_1[2] = document.getElementById('lbl_tip_1_2');
	lbl_tip_2[1] = document.getElementById('lbl_tip_2_1');
	lbl_tip_2[2] = document.getElementById('lbl_tip_2_2');

	txt_tip[1] = document.getElementById('txt_tip_1');
	txt_tip[2] = document.getElementById('txt_tip_2');
	txt_tip[3] = document.getElementById('txt_tip_3');
	txt_tip[4] = document.getElementById('txt_tip_4');
	txt_tip[5] = document.getElementById('txt_tip_5');
    
	star[1] = document.getElementById('star_1');
	star[2] = document.getElementById('star_2');
	star[3] = document.getElementById('star_3');
	star[4] = document.getElementById('star_4');
	star[5] = document.getElementById('star_5');
    
    ul_monedas = document.getElementById('ul_monedas');

	ddl_moneda[0] = document.getElementById('ddl_moneda');
	ddl_moneda[1] = document.getElementById('ddl_moneda_1');
	ddl_moneda[2] = document.getElementById('ddl_moneda_2');

	txt_moneda[1] = document.getElementById('txt_moneda_1');
	txt_moneda[2] = document.getElementById('txt_moneda_2');
	
	txt_cambio =  document.getElementById('txt_cambio');
    
	fun_queue = [];
	fun_lock = false;

	LoadMonedas();

	ReadData();
	
	Reset();
	
}

function Update(c, v){
	valor[c] = v;
	if(1 == c){
		valor[2] = valor[c] * ratio;
	}else{
		valor[1] = valor[c] / ratio;
	}
	UpdateDisplay();
}

function SetCharAt(s, i, c) {
	return s.substr(0, i) + c + s.substr(i + 1);
}

function DoHaptic(){
    if(haptic){
        navigator.vibrate(haptic_time);
    }
}

function SetNum(obj, c, n) {
	EnQueue(_setNum, [obj, c, n]);
    DoHaptic();
}

function _setNum(obj, c, n){
	AddClass(obj,'down');
	var v = valor[c]; 
	if(newNum || (curr != c && 0 <= n)){
		v = 0;
		newNum = false;
	}
    curr = c;
	var parts = (Math.round(parseFloat(v) * pow[c]) / pow[c]).toFixed(dec[c]);
	if(parts.indexOf('.') < 0){
		parts += ".00";
	}
	parts = parts.split(".");
    if(0 > n){
        if(parts[1]*1 == 0){
            if(parts[0].length == 1){
				parts[0] = "0";
			}else{
				parts[0] =  parts[0].substring(0, parts[0].length-1);
			}            
        }else{
            for(var i = dec[c]-1; i >= 0; --i){
                if(parts[1].charAt(i) != 0){
                    parts[1] = SetCharAt(parts[1], i, '0');
                    i = -1;
                }
            }
        }
    }else if(0 < dec_pos[c]){
        parts[1] = SetCharAt(parts[1], dec_pos[c]-1, n.toString()[0]);
        dec_pos[c]++;
		if(dec_pos[c] > dec[c] || 0 >= dec_pos[c]){
			dec_pos[c] = 0;
			DelClass(btn_d[c], 'down');
		}
    }else{
        parts[0] += n;
    }
	v =  parseFloat(parts.join("."));
	Update(c, v);
	setTimeout(function(){DelClass(obj, 'down');}, 100);
	
}	

function SetDec(c) {
	EnQueue(_setDec, [c]);
    DoHaptic();
}

function _setDec(c){
	if(dec[c] == 0){
		return;
	}
	if(0 == dec_pos[c]){
		dec_pos[c] = 1;
		AddClass(btn_d[c], 'down');
	}else{
		dec_pos[c] = 0;
		DelClass(btn_d[c], 'down');
	}
}

function SetCmd(obj, cmd){
	EnQueue(_setCmd, [obj, cmd]);
    DoHaptic();
}

function _setCmd(obj, cmd){
	AddClass(obj, 'down');
	if("CE" == cmd){
		setTimeout(function(){DelClass(obj, 'down');}, 100);
		Reset();
	}else{
		if("" != op){
			var v1 = valor[0];
			var v2 = valor[1];
			var r = 0;
			switch(op){
				case "*":
					r = v1 * v2;
					DelClass(btn_mult, 'down');
					break;
				case "/":
					r = v1 / v2;
					DelClass(btn_div, 'down');
					break;
				case "+":
					r = v1 + v2;
					DelClass(btn_plus, 'down');
					break;
				case "-":
					r = v1 - v2;
					DelClass(btn_minus, 'down');
					break;
			}
			Update(1, r);
			if(cmd != "="){
				op = cmd;
				valor[0] = valor[1]; 
				newNum = true;
			}else{
				op = "";
				setTimeout(function(){DelClass(obj, 'down');}, 100);
			}
		}else{
			if(cmd != "="){
				op = cmd;
				valor[0] = valor[1]; 
				newNum = true;
			}else{
				op = "";
				setTimeout(function(){DelClass(obj, 'down');}, 100);
			}
		}
	}
}

function CloseCfg(){
	curPage = 0;
    div_config.style.display = "none"; 
    DoHaptic();
}

function OpenCfg(){
	curPage = 1;
    div_config.style.display = "block"; 
    DoHaptic();
}

function Refresh(){
    DoHaptic();
	div_load.style.display = "block"; 
	curPage = 3;
    var data_file = "http://api.fixer.io/latest?base=" + moneda[1] + "&symbols=" + moneda[2];
	var http_request = new XMLHttpRequest();
	try{
      http_request = new XMLHttpRequest();
	}catch(err){
		try{
			http_request = new ActiveXObject("Msxml2.XMLHTTP");
		}catch(err){
			try{
				http_request = new ActiveXObject("Microsoft.XMLHTTP");
			}catch(err){
                alert("Refresh failed.");
				return false;
			}
		}
	}
	http_request.ontimeout = function(){
		alert("Refresh failed.");
		div_load.style.display = "none"; 
	};
	http_request.onreadystatechange = function(){
		if(http_request.readyState == 4){
			if(http_request.status == 200){
				try{
					var jsonObj = JSON.parse(http_request.responseText);
					ratio = jsonObj.rates[moneda[2]];
					SetDB(moneda[1] + '-' + moneda[2], ratio);
					txt_cambio.value = ratio;
					Reset();
				}catch(err){
					alert("Refresh failed.");
				}
			}else{
				alert("Refresh failed.");
			}
			div_load.style.display = "none"; 
			curPage = 1;

		}
	};
	http_request.open("GET", data_file, true);
	http_request.timeout = 5000;
	http_request.send();
	
}

function SetStar(n) {
	EnQueue(_setStar, [n]);
    DoHaptic();
}

function _setStar(n){
    stars = n;
    star[1].src = n>0?"img/star_on.png":"img/star_off.png";
    star[2].src = n>1?"img/star_on.png":"img/star_off.png";
    star[3].src = n>2?"img/star_on.png":"img/star_off.png";
    star[4].src = n>3?"img/star_on.png":"img/star_off.png";
    star[5].src = n>4?"img/star_on.png":"img/star_off.png";
    UpdateTips();
	SetDB("star", n);	
}

function ChangeTip() {
	EnQueue(SetTips, [!show_tips]);
    DoHaptic();
}

function SetTips(v){
	show_tips = v;
	if(show_tips){
		div_tips.style.display = "block"; 
		btn_tips.src = "img/chk_on.png";
	}else{
        div_tips.style.display = "none";	
		btn_tips.src = "img/chk_off.png";
	}
	SetDB("tips", show_tips);	
}

function ChangeHaptic() {
	EnQueue(SetHaptic, [!haptic]);
    navigator.vibrate(haptic_time);
}

function SetHaptic(v){
    haptic = v;
    if(haptic){
		btn_haptic.src = "img/chk_on.png";
	}else{
		btn_haptic.src = "img/chk_off.png";
	}
	SetDB("haptic", haptic);	
}

function ReadData(){
	SetStar(ReadDB("star", 3));
	SetTips(ReadDB("tips", true));
	SetHaptic(ReadDB("haptic", true));
	_setMoneda(1, ReadDB("moneda1", "EUR"));
	_setMoneda(2, ReadDB("moneda2", "USD"));
	tips[1] = ReadDB("tip_1", 0.050);
	tips[2] = ReadDB("tip_2", 0.075);
	tips[3] = ReadDB("tip_3", 0.100);
	tips[4] = ReadDB("tip_4", 0.125);
	tips[5] = ReadDB("tip_5", 0.150);
	txt_tip[1].value = Math.round(tips[1] * 10000) / 100;
	txt_tip[2].value = Math.round(tips[2] * 10000) / 100;
	txt_tip[3].value = Math.round(tips[3] * 10000) / 100;
	txt_tip[4].value = Math.round(tips[4] * 10000) / 100;
	txt_tip[5].value = Math.round(tips[5] * 10000) / 100;
	Reset();
}

function SetMoneda(id){
	curPage = 1;
	_setMoneda(cur_ddl_moneda, id);
	SetDB("moneda"+cur_ddl_moneda, id);
	ddl_moneda[0].style.display = "none"; 
    DoHaptic();
}

function _setMoneda(n, value){
	moneda[n] = value;
	var str = monedas[value].Name + ' (' + value + ')';
	txt_moneda[n].innerHTML = str;
	ddl_moneda[n].innerHTML = str;
	
	dec[n] = monedas[value].Dec;
	pow[n] = Math.pow(10, dec[n]);
	
	ratio = ReadDB(moneda[1] + '-' + moneda[2], 1);
	
	txt_cambio.value = ratio;
	

	
	if(moneda[1] == "CU1" || moneda[1] == "CU2" || moneda[2] == "CU1" || moneda[2] == "CU2"){
		btn_refresh.style.display = "none"; 
	}else{
		btn_refresh.style.display = "inline-block"; 
	}
	
	Reset();
}

function ReadDB(id, dfl){
	var rtn = null;
	rtn = localStorage.getItem("C2@" + id);
	if(rtn == null || rtn == "" || rtn === null || rtn === "undefined"){
		rtn = dfl;
	}
	return rtn;
}

function SetDB(id, value){
	localStorage.setItem("C2@" + id, value);
}

function LoadMonedas(){
	ul_monedas.innerHTML = "";
	var str = "";
	for(var key in monedas){
		str += '<li id="li_' + monedas[key].ID + '" onclick="' + "SetMoneda('" + monedas[key].ID + "')" + '">' + monedas[key].Name + ' (' + monedas[key].ID + ')</li>';
	}
	ul_monedas.innerHTML = str;
	
	for(var key2 in monedas){
		monedas[key2].ctrl = document.getElementById('li_' + monedas[key2].ID);
	}
}

function SelectMoneda(n){
	curPage = 2;
	cur_ddl_moneda = n;
	
	for(var key in monedas){
		if(moneda[n] == key){
			AddClass(monedas[key].ctrl, 'selected');
		}else{
			DelClass(monedas[key].ctrl, 'selected');
		}
		
	}
	
	ddl_moneda[0].style.display = "block"; 
    DoHaptic();
}

function UpdateRate(){
	ratio = txt_cambio.value;
	SetDB(moneda[1] + '-' + moneda[2], ratio);
	Reset();
}

function UpdateTip(n){
	tips[n] = txt_tip[n].value / 100;
	SetDB("tip_" + n, tips[n]);
	Reset();
}

function hideSplashScreen(){
    if(navigator.splashscreen && navigator.splashscreen.hide){
        navigator.splashscreen.hide();
    }
    if(window.intel && intel.xdk && intel.xdk.device){
        if(intel.xdk.device.hideSplashScreen){
            intel.xdk.device.hideSplashScreen();
        }
    }
}

monedas = {
	AUD: {ID: 'AUD', Name: 'Australia Dollar', Dec: 2},
	BRL: {ID: 'BRL', Name: 'Brazil Real', Dec: 2},
	BGN: {ID: 'BGN', Name: 'Bulgarian Lev', Dec: 2},
	CAD: {ID: 'CAD', Name: 'Canada Dollar', Dec: 2},
	CNY: {ID: 'CNY', Name: 'China Yuan Renminbi', Dec: 2},
	HRK: {ID: 'HRK', Name: 'Croatian Kuna', Dec: 2},
	CZK: {ID: 'CZK', Name: 'Czech Republic Koruna', Dec: 0},
	DKK: {ID: 'DKK', Name: 'Denmark Krone', Dec: 2},
	EUR: {ID: 'EUR', Name: 'Euro', Dec: 2},
	HKD: {ID: 'HKD', Name: 'Hong Kong Dollar', Dec: 2},
	HUF: {ID: 'HUF', Name: 'Hungary Forint', Dec: 0},
	INR: {ID: 'INR', Name: 'India Rupee', Dec: 2},
	IDR: {ID: 'IDR', Name: 'Indonesia Rupiah', Dec: 0},
	ILS: {ID: 'ILS', Name: 'Israel Shekel', Dec: 2},
	JPY: {ID: 'JPY', Name: 'Japan Yen', Dec: 0},
	KRW: {ID: 'KRW', Name: 'Korea (South) Won', Dec: 0},
	MYR: {ID: 'MYR', Name: 'Malaysia Ringgit', Dec: 2},
	MXN: {ID: 'MXN', Name: 'Mexico Peso', Dec: 2},
	NZD: {ID: 'NZD', Name: 'New Zealand Dollar', Dec: 2},
	NOK: {ID: 'NOK', Name: 'Norway Krone', Dec: 0},
	PHP: {ID: 'PHP', Name: 'Philippines Peso', Dec: 2},
	PLN: {ID: 'PLN', Name: 'Poland Zloty', Dec: 2},
	RON: {ID: 'RON', Name: 'Romanian Leu', Dec: 2},
	RUB: {ID: 'RUB', Name: 'Russia Ruble', Dec: 2},
	SGD: {ID: 'SGD', Name: 'Singapore Dollar', Dec: 2},
	ZAR: {ID: 'ZAR', Name: 'South Africa Rand', Dec: 2},
	SEK: {ID: 'SEK', Name: 'Sweden Krona', Dec: 0},
	CHF: {ID: 'CHF', Name: 'Switzerland Franc', Dec: 2},
	THB: {ID: 'THB', Name: 'Thailand Baht', Dec: 2},
	TRY: {ID: 'TRY', Name: 'Turkey Lira', Dec: 2},
	GBP: {ID: 'GBP', Name: 'United Kingdom Pound', Dec: 2},
	USD: {ID: 'USD', Name: 'United States Dollar', Dec: 2},
	CU1: {ID: 'CU1', Name: 'Custom 1', Dec: 2},
	CU2: {ID: 'CU2', Name: 'Custom 2', Dec: 2},
	CU3: {ID: 'CU3', Name: 'Custom 3', Dec: 2}
};

document.addEventListener("deviceready", function(){
    Init();

	if ( window.plugins && window.plugins.AdMob ) {
		window.plugins.AdMob.setOptions( {
			publisherId: "ca-app-pub-6314852935422955/9694694429",
			bannerAtTop: true,
			overlap: false,
			offsetTopBar: true,
			autoShow: true,
			isTesting: false
		});
	}
	setTimeout(function(){
		hideSplashScreen();
		window.plugins.AdMob.createBannerView();
	}, 1000);

}, false);

document.addEventListener("backbutton", function(){
	switch(curPage){
		case 0:
			navigator.app.exitApp();
			break;
		case 1:
			curPage = 0;
			div_config.style.display = "none"; 
			break;
		case 2:
			curPage = 1;
			ddl_moneda[0].style.display = "none"; 
			break;
		case 3:
			div_load.style.display = "none"; 
			curPage = 1;
			break;
	}

}, false);




